void forward_reply_to_appl(FD_INIT_LIST *appl, uint8_t err, uint8_t r_status, struct in6_addr *relay_addr,
			   char *msg, uint32_t start_of_ext, uint32_t total_len){
  HEADER_CLIENTD_PACKET header;
  char res[3];
  uint8_t i = 0;
  uint32_t len;

  bzero(res, sizeof(res));

  header.msg_type   = DHCP_REPLY;
  header.error      = err;
  header.pid        = htons(appl->pid);
  header.request_no = htonl(appl->request_no);

  iov[i].iov_base   = (char *)&header;
  iov[i].iov_len    = sizeof(header);
  len               = iov[i++].iov_len;

  iov[i].iov_base   = res;
  iov[i].iov_len    = sizeof(res);
  len              += iov[i++].iov_len;

  iov[i].iov_base   = (char *)&r_status;
  iov[i].iov_len    = sizeof(r_status);
  len              += iov[i++].iov_len;

  if(GET_BITS_HIGH(r_status, 1, 8)){
    iov[i].iov_base  = (char *)relay_addr;
    iov[i].iov_len   = sizeof(*relay_addr);
    len             += iov[i++].iov_len;
  }

  iov[i].iov_base   = msg + start_of_ext;
  iov[i].iov_len    = total_len - start_of_ext;
  len              += iov[i++].iov_len;

  if(writev(appl->tcp_fd, &iov[0], i) != len)
    err_dump("Error in sending reply to appl. Exiting...");
}
