# define JUNK
#ifndef PRINT
# define PRINT
#endif

FD_INIT_LIST *t_init;

void handle_reply_from_server(char msg[], int len, struct sockaddr_in6 *server){
  int                  size;
  uint32_t             length_read;
  TYPE_LEN             tl;
  char name[64];

  temp_msg_type = (uint8_t *) msg;

  switch(*temp_msg_type){

  case DHCP_ADVERTISE:
    {
      ADVERTISE            adv;
      SERVER_SOLICIT_INFO *temp_serv_sol, *prev_serv_sol;
      SUBNET_PREFIX_INFO  *temp_sub_pre, *prev_sub_pre;
      uint8_t              prefix_len;

#ifdef PRINT
      {
	print_packet(msg, len);
	printf(" server = %s. Press enter to continue: ",
	       inet_ntop(AF_INET6, &server->sin6_addr, name, 64));
	//getchar();
      }
#endif

      size = sizeof(adv);

      if(len < size){
	printf("Invalid DHCP_ADVERTISE from server. Ignoring...\n");
	return;
      }
      memcpy(&adv, msg, size);
      length_read = size;

      /* Scan the init list for an entry with sol_xact_id = adv.solicit_id */
      for(t_init = fd_init_list_head; t_init; t_init = t_init->next){

	if(t_init->sol_xact_id == GET_ADV_SOLICIT_ID(adv.reserved_solicit_id) &&
	   t_init->request_pending &&
	   *((uint8_t *)t_init->msg) == DHCP_SOLICIT &&
	   IN6_ARE_ADDR_EQUAL(t_init->interface->link_local_addr,
			      &adv.client_link_local_addr)){
	  
	  // Imp:t_init->request_pending = 0;
	  if(!IN6_ARE_ADDR_EQUAL(&server->sin6_addr, &adv.server_addr))
	    printf("Addresses of server in message and obtained from udp source don't match\n\n");
	  
#ifdef DEBUG
	  printf("Adding adv from server to solicit list of process %d\n", t_init->pid);
#endif
	  
	  if(t_init->adv_received == 0){
	    /* This is the first advertise message. Set advertise time */
	    {
	      TIME temp_time;
	      if(gettimeofday(&temp_time, NULL))
		errx("Error in gettimeofday. Exiting...\n");

	      printf("Actual time of writing first message into solicit list %u %u\n",
		     temp_time.tv_sec, temp_time.tv_usec);

	    }
	    t_init->advertise_time            = current_time;
	    t_init->timeout                   = SRVR_PREF_WAIT * 1000;
	    add_in_ms(&current_time,
		       SRVR_PREF_WAIT * 1000,
		       &t_init->next_transmission);
	    /* Imp: set min(sleep time for clientd) */
	    /* clear entire server solicit list as a new one would now result */
	    clear_server_solicit_list(t_init->sol_list_head);
	    t_init->adv_received = 1;
	  }
	  
#ifdef JUNK
	  printf("1\n");
#endif
	  for(prev_serv_sol = NULL, temp_serv_sol = t_init->sol_list_head;
	      temp_serv_sol;
	      prev_serv_sol = temp_serv_sol, temp_serv_sol = temp_serv_sol->next
	      ){
#ifdef JUNK
	    printf("\t\t\tpreference %u\n",temp_serv_sol->preference );
#endif
	    if(IN6_IS_ADDR_UNSPECIFIED(&temp_serv_sol->server_addr))
	      /* This is the first free entry where we can copy current adv info */
	      break;
	  }

#ifdef JUNK
	  printf("2\n");
#endif
	  
	  if(!temp_serv_sol){
	    temp_serv_sol = (SERVER_SOLICIT_INFO *) malloc(sizeof(SERVER_SOLICIT_INFO));
	    bzero((char *) temp_serv_sol, sizeof(*temp_serv_sol));
	    
	    if(!prev_serv_sol)
	      t_init->sol_list_head = temp_serv_sol;
	    else
	      prev_serv_sol->next = temp_serv_sol;
	  }

#ifdef JUNK
	  printf("3\n");
#endif
	  /* Now you can fill up the data from solicit in temp_serv_sol */
	  temp_serv_sol->relay_addr      = adv.relay_addr;
	  temp_serv_sol->server_addr     = adv.server_addr;
	  temp_serv_sol->preference      = adv.preference;
	  temp_serv_sol->no_of_prefixes  = 0;

#ifdef JUNK
	  {
	    char name[64];
	    printf("preference = %u addr = %s\n", temp_serv_sol->preference,
		   inet_ntop(AF_INET6, &server->sin6_addr, name, 64));
	  }
#endif
	  for(prev_sub_pre = NULL, temp_sub_pre = temp_serv_sol->subnet_prefix_info_head;
	      length_read < len;
	      prev_sub_pre = temp_sub_pre, temp_sub_pre = temp_sub_pre->next
	      ){
	    memcpy(&tl, msg + length_read, sizeof(tl));
	    length_read += sizeof(tl);
	    tl.type      = ntohs(tl.type);
	    tl.length    = ntohs(tl.length);

	    if(tl.type != SUBNET_PREFIX_EXTENSION){
	      printf("Invalid extension type %d in advertise message\n", tl.type);
	      /* Skip this portion */
	      length_read += tl.length;
	      continue;
	    }
	    if(!temp_sub_pre){
	      temp_sub_pre = (SUBNET_PREFIX_INFO *) malloc(sizeof(SUBNET_PREFIX_INFO));
	      bzero((char *) temp_sub_pre, sizeof(SUBNET_PREFIX_INFO));

	      if(!prev_sub_pre)
		temp_serv_sol->subnet_prefix_info_head = temp_sub_pre;
	      else
		prev_sub_pre->next = temp_sub_pre;
	    }
	    memcpy(&prefix_len, msg + length_read, sizeof(prefix_len));

	    if(tl.length != (1 + (prefix_len + 7)/8))
	      printf("Calculated and mentioned lengths don't match in subnet prefix extension\n");

	    memcpy(temp_sub_pre->prefix_len_octets, msg + length_read, tl.length);
	    length_read += tl.length;
	    temp_serv_sol->no_of_prefixes++;
	  } 
	  //Imp: send_adv_to_appl(t_init);
	}
      }
      
    }
    break;

  case DHCP_REPLY:
    {
      REPLY            rep;
      struct in6_addr  relay_addr;
      uint8_t          err      = 0;
      uint8_t          free_msg = 0;
      uint32_t         start_of_ext;
      
      size = sizeof(rep);
      if(len < size){
	printf("Invalid DHCP_REPLY from server. Ignoring...\n");
	return;
      }
      memcpy(&rep, msg, size);
      rep.transaction_id = ntohs(rep.transaction_id);
      length_read = size;
      
      /* Scan the init list for an entry with sol_xact_id = rep.transaction_id */
      for(t_init = fd_init_list_head; t_init; t_init = t_init->next){
	if(t_init->sol_xact_id == rep.transaction_id &&
	   t_init->request_pending &&
	   (*((uint8_t *)t_init->msg) == DHCP_REQUEST ||
	    *((uint8_t *)t_init->msg) == DHCP_RELEASE) &&
	   IN6_ARE_ADDR_EQUAL(t_init->interface->link_local_addr,
			      &rep.client_link_local_addr) /*&&
	   IN6_ARE_ADDR_EQUAL(&(t_init->serv_sockaddr).sin6_addr,
	   &server->sin6_addr)* Server which replied is same as to whom msg was sent*/
	   ){
	  printf("sent to %s recvd from %s\n",
		 inet_ntop(AF_INET6, &(t_init->serv_sockaddr).sin6_addr, name, 64),
		 inet_ntop(AF_INET6, &server->sin6_addr, name, 64));
	  t_init->request_pending = 0;
	  t_init->no_of_attempts  = 0;
	  
	  if(GET_R(rep.r_status)){
	    memcpy(&relay_addr, msg + length_read, sizeof(relay_addr));
	    length_read += sizeof(relay_addr);
	    /*
	     * Imp: I don't know what to do with the relay address. I will
	     * just return it to the appl.
	     */
	  }
	  start_of_ext = length_read;

	  if(GET_STATUS(rep.r_status) != 0){
	    /* Imp: Return error back to appl */
	    err = 2;
#ifdef DEBUG
	    printf("Server returned error status = %u\n", GET_STATUS(rep.r_status));
#endif
	    /*Imp: You must process the extensions even if status = error
	    forward_reply_to_appl(t_init, err, rep.r_status, &relay_addr, msg,
				  start_of_ext, len);
	    break;
	    */
	  }

	  if(*((uint8_t *)t_init->msg) == DHCP_RELEASE){
	    printf("Release are handled when request from appl comes\n");
	    forward_reply_to_appl(t_init, err, rep.r_status, &relay_addr, msg,
				  start_of_ext, len);
	    break;
	  }
		
	  while(length_read < len){

	    memcpy(&tl, msg + length_read, sizeof(tl));
	    length_read += sizeof(tl);
	    tl.type      = ntohs(tl.type);
	    tl.length    = ntohs(tl.length);
  
	    switch(tl.type){

	    case IP_ADDRESS_EXTENSION:
	      {
		struct{
		  uint32_t status     : 8;
		  uint32_t C          : 1;
		  uint32_t I          : 1;
		  uint32_t L          : 1;
		  uint32_t Q          : 1;
		  uint32_t A          : 1;
		  uint32_t P          : 1;
		  uint32_t reserved   : 8;
		  uint32_t scope      : 3;
		  uint32_t prefix_len : 7;
		} s;

		uint32_t         temp_ext;
		/* Make the following three variables: ip_addr, preferred_lifetime, valid_lifetime
		 * as global: for DSTM
		 */
		struct in6_addr  ip_addr;
		uint32_t         preferred_lifetime, valid_lifetime, old_length, name_size;
		char             dns_name[MAX_DNS_NAME];
		IADDR           *temp_iaddr;
		FD_INFO         *temp_fd_info, prev_fd_info;
		
		name_size    = 0;
		old_length   = length_read;
		memcpy(&temp_ext, msg + length_read, sizeof(temp_ext));
		length_read += sizeof(temp_ext);

		temp_ext     = ntohl(temp_ext);
		s.status     = GET_BITS_HIGH(temp_ext, 8, 32);
		s.C          = GET_BITS_MIDDLE(temp_ext, 24, 1);
		s.I          = GET_BITS_MIDDLE(temp_ext, 23, 1);
		s.L          = GET_BITS_MIDDLE(temp_ext, 22, 1);
		s.Q          = GET_BITS_MIDDLE(temp_ext, 21, 1);
		s.A          = GET_BITS_MIDDLE(temp_ext, 20, 1);
		s.P          = GET_BITS_MIDDLE(temp_ext, 19, 1);
		s.reserved   = 0;
		s.scope      = GET_BITS_MIDDLE(temp_ext, 10, 3);
		s.prefix_len = GET_BITS_MIDDLE(temp_ext, 7, 7);

		if(s.status != 0) {
#ifdef DEBUG
		  printf("Non-zero status field in IP Address Extension in reply\n");
#endif
		  length_read = old_length + tl.length;
		  break;
		}
		if(s.C){
		  memcpy(& ip_addr, msg + length_read, sizeof(struct in6_addr));
		  length_read += sizeof(struct in6_addr);
		}
		
		if(s.L){
		  memcpy(& preferred_lifetime, msg + length_read, sizeof(preferred_lifetime));
		  length_read += sizeof(preferred_lifetime);
		  memcpy(& valid_lifetime, msg + length_read, sizeof(valid_lifetime));
		  length_read += sizeof(valid_lifetime);
		  preferred_lifetime = ntohl(preferred_lifetime);
		  valid_lifetime     = ntohl(valid_lifetime);
		}
		
		if((length_read - old_length) < tl.length){
		  /* This means DNS name is present. Read it off */
		  name_size           = tl.length - (length_read - old_length);
		  memcpy(dns_name, msg + length_read, name_size);
		  length_read        += name_size;
		  dns_name[name_size] = '\0';
		  /* length_read = tl.length + old_length is also equally correct */
#ifdef DEBUG
		  printf("DNS name = %s in IP ADDRESS EXTENSION\n", dns_name);
#endif
		  
		}

		if(s.C && !s.I && s.L && *((uint8_t *)t_init->msg) == DHCP_REQUEST){
		  /*
		   * Server has leased a new address or extended the lease
		   * Add it to the list of addresses of the interface on which
		   * request was made.
		   * Imp: Update lease file appropriately
		   */
		  
		  for(temp_iaddr = t_init->interface->addr_list_head;
		      temp_iaddr;
		      temp_iaddr = temp_iaddr->next
		      )
		    if(IN6_ARE_ADDR_EQUAL(& temp_iaddr->ip_addr, &ip_addr))
		      break;
		  
		  if(temp_iaddr){
		    /* Server has extended the lease of the address */
#ifdef DEBUG
		    printf("Server has extended the lease of %s\n",
			 inet_ntop(AF_INET6, &ip_addr, name, 64));
#endif
		    if(!IN6_ARE_ADDR_EQUAL(& temp_iaddr->server_addr,
					   & server->sin6_addr)){
		      warnx("The address of server who leased the address and source"
			    "address don't match\n");
		    }
		    
		    if(valid_lifetime == 0){
		      /* Server is trying to invalidate the lease */
		      int deleted = -1;
#ifdef DEBUG
		      printf("Deleting address from interface %u\n",
			     t_init->interface->index);
#endif
		      delete_from_list(temp_iaddr, &t_init->interface->addr_list_head);
		      
		      /* Delete the socket descriptor opened for this address */
		      /*for(prev_fd_info = NULL,
			    temp_fd_info = t_init->interface->ip_addr_fd_head;
			  temp_fd_info;
			  prev_fd_info = temp_fd_info, temp_fd_info = temp_fd_info->next
			  ){
			if(IN6_ARE_ADDR_EQUAL(temp_fd_info->i_addr->ip_addr, ip_addr)){
			  if(temp_fd_info->i_addr == temp_iaddr){
			  
			  close(temp_fd_info->fd);
			  FD_CLR(temp_fd_info->fd, &temp_f);
			  
			  if(prev_fd_info)
			    prev_fd_info->next = temp_fd_info->next;
			  else
			    t_init->interface->ip_addr_fd_head = temp_fd_info->next;
			  
			  free(temp_fd_info);
			  deleted = 1;
			  break;
			}
			}*/
		      deleted = delete_address_info(&ip_addr, t_init->interface);
		      if(deleted == -1)
			printf("Impossible! Address without socket descriptor info\n");
		      else
			FD_CLR(deleted, &temp_f);

		      break;
		    }

		    temp_iaddr->when_leased        = current_time;
		    temp_iaddr->preferred_lifetime = preferred_lifetime;
		    temp_iaddr->valid_lifetime     = valid_lifetime;
		    break;
		  }

#ifdef DEBUG
		  printf("Server has leased a new address %s\n",
			 inet_ntop(AF_INET6, &ip_addr, name, 64));
#endif
		  temp_iaddr          = (IADDR *) malloc(sizeof(IADDR));
		  temp_fd_info        = (FD_INFO *) malloc(sizeof(FD_INFO));

		  temp_iaddr->ip_addr = ip_addr;

		  if(name_size > 0)
		    strcpy(temp_iaddr->dns_name, dns_name);
		  else
		    temp_iaddr->dns_name[0]      = '\0';

		  temp_iaddr->server_addr        = server->sin6_addr;
		  temp_iaddr->when_leased        = current_time;
		  temp_iaddr->preferred_lifetime = preferred_lifetime;
		  temp_iaddr->valid_lifetime     = valid_lifetime;
		  insert_in_list(temp_iaddr, &t_init->interface->addr_list_head);
	
		  temp_fd_info->i_addr = temp_iaddr;
		  temp_fd_info->fd     = socket(AF_INET6, SOCK_DGRAM, 0);
		  if(temp_fd_info->fd < 0)
		    err_dump("Error in opening datagram socket! Exiting...");
		  
		  FD_SET(temp_fd_info->fd, &temp_f);
		  nfds = (nfds > temp_fd_info->fd) ? nfds : temp_fd_info->fd;
		  
		  bzero((char *) &temp_fd_info->sockaddr, sizeof(temp_fd_info->sockaddr));
		  
#ifdef SIN6_LEN
		  temp_fd_info->sockaddr.sin6_len      = sizeof(temp_fd_info->sockaddr);    
#endif
		  
		  temp_fd_info->sockaddr.sin6_family   = AF_INET6;                          
		  temp_fd_info->sockaddr.sin6_port     = htons(CLIENT_PORT);                
		  temp_fd_info->sockaddr.sin6_flowinfo = 0;                                 
		  temp_fd_info->sockaddr.sin6_addr     = ip_addr;                 
		  temp_fd_info->sockaddr.sin6_scope_id = 0;                                 
		  
		  if(bind(temp_fd_info->fd, (struct sockaddr *) &temp_fd_info->sockaddr,
			  sizeof(temp_fd_info->sockaddr)) < 0){
		    printf("Error while binding new address of interface %d ! Address = ", 
			   t_init->interface->index);

		    temp_fd_info->next = t_init->interface->ip_addr_fd_head;
		    t_init->interface->ip_addr_fd_head = temp_fd_info;
		  }
		}
		
	      }
	      break;
	      
	    case MAX_DHCP_MESSSAGE_SIZE_EXTENSION:
	      {
		uint32_t max_dhcp_msg_size;

		if(tl.length != sizeof(max_dhcp_msg_size)){
		  printf("Corrupt MAX_DHCP_MESSSAGE_SIZE_EXTENSION\n");
		  break;
		}
		memcpy(& max_dhcp_msg_size, msg + length_read, sizeof(max_dhcp_msg_size));
		length_read      += tl.length;
		max_dhcp_msg_size = ntohl(max_dhcp_msg_size);

		if(max_dhcp_msg_size > LINK_MTU &&
		   max_dhcp_msg_size >MAX_DHCP_MSG){ /* LINK_MTU = 1280 */
		  MAX_DHCP_MSG = max_dhcp_msg_size;
		  free_msg == 1;
		}
	      }
	      break;

	    case DHCP_RETRANS_CONF_PARAM_EXTENSION:
	      {
		/* Imp: I Have to decide on numbers for conf params */
	      }
	      break;

	    case RECONFIGURE_MULTICAST_ADDR_EXTENSION:
	      {
		struct in6_addr   m_addr;
		REC_MULTICAST    *temp_rec;
		struct ipv6_mreq  socket_opt;

		if(tl.length != sizeof(struct in6_addr)){
		  printf("Corrupt RECONFIGURE_MULTICAST_ADDR_EXTENSION\n");
		  break;
		}
		memcpy(& m_addr, msg + length_read, sizeof(struct in6_addr));
		length_read      += tl.length;
		
		temp_rec     = (REC_MULTICAST *) malloc(sizeof(REC_MULTICAST));
		temp_rec->fd = socket(AF_INET6, SOCK_DGRAM, 0);
		if(temp_rec->fd < 0)
		  err_dump("Error in opening datagram socket! Exiting...");
		
		FD_SET(temp_rec->fd, &temp_f);
		nfds = (nfds > temp_rec->fd) ? nfds : temp_rec->fd;
		
		bzero((char *) &temp_rec->m_sock, sizeof(temp_rec->m_sock));
		
#ifdef SIN6_LEN
		temp_rec->m_sock.sin6_len      = sizeof(temp_rec->m_sock);    
#endif
		
		temp_rec->m_sock.sin6_family   = AF_INET6;
		temp_rec->m_sock.sin6_port     = htons(CLIENT_PORT);
		temp_rec->m_sock.sin6_flowinfo = 0;
		temp_rec->m_sock.sin6_addr     = m_addr;
		temp_rec->m_sock.sin6_scope_id = 0;
		
		socket_opt.ipv6mr_multiaddr    = m_addr;
		socket_opt.ipv6mr_interface    = t_init->interface->index;

		if(setsockopt(temp_rec->fd, IPPROTO_IPV6, IPV6_JOIN_GROUP, (char *) &socket_opt,
			      sizeof(socket_opt) == -1))
		  err_dump("Couldn't set socket option to IPV6_JOIN_GROUP. Exiting...");	
		
		if(bind(temp_rec->fd, (struct sockaddr *) &temp_rec->m_sock,
			sizeof(temp_rec->m_sock)) < 0){
		  printf("Error while binding multicast address to interface %d\n",
			 t_init->interface->index);
		  
		}
		/* Insert the opened fd into list of multicast fds opened for this appl */
		temp_rec->next = t_init->rec_list_head;
		t_init->rec_list_head = temp_rec;
	      }
	      break;

	    case RENUMBER_DHCP_SERVER_ADDR_EXTENSION:
	      {
		struct in6_addr      prev_addr, new_addr;
		IADDR               *temp_iaddr;
		SERVER_SOLICIT_INFO *temp_serv_sol_info;

		if(tl.length != (2 * sizeof(struct in6_addr))){
		  printf("Corrupt RENUMBER_DHCP_SERVER_ADDR_EXTENSION\n");
		  break;
		}

		memcpy(&prev_addr, msg + length_read, sizeof(struct in6_addr));
		length_read += sizeof(struct in6_addr);
		memcpy(&new_addr, msg + length_read, sizeof(struct in6_addr));
		length_read += sizeof(struct in6_addr);
		/* Change server address in list of address of this interface */
		for(temp_iaddr = t_init->interface->addr_list_head;
		    temp_iaddr;
		    temp_iaddr = temp_iaddr->next){
		  if(IN6_ARE_ADDR_EQUAL(&temp_iaddr->server_addr, 
					&prev_addr)){
		    temp_iaddr->server_addr = new_addr;
		  }
		}
		/* 
		 * Now change server solicit list of both this interface
		 * as well as the one with this appl
		 */
		for(temp_serv_sol_info = t_init->interface->sol_list_head;
		    temp_serv_sol_info;
		    temp_serv_sol_info = temp_serv_sol_info->next){
		  if(IN6_ARE_ADDR_EQUAL(&temp_serv_sol_info->server_addr, 
					&prev_addr)){
		    temp_serv_sol_info->server_addr = new_addr;
		  }
		}

		for(temp_serv_sol_info = t_init->sol_list_head;
		    temp_serv_sol_info;
		    temp_serv_sol_info = temp_serv_sol_info->next){
		  if(IN6_ARE_ADDR_EQUAL(&temp_serv_sol_info->server_addr, 
					&prev_addr)){
		    temp_serv_sol_info->server_addr = new_addr;
		  }
		}
		
	      }
	      break;
	      
	    default:
	      /* Ignore the extension */
	      length_read += tl.length;
	      break;
	    }/* switch */
	  }
	  /* Imp: Compose reply for appl */
	  forward_reply_to_appl(t_init, err, rep.r_status, &relay_addr, msg,
				start_of_ext, len);
	  //printf("You need to compose reply for appl\n");
	  if(free_msg){
	    /*
	     * Note CLD has to change both send_msg and recv_msg because
	     * if server is willing to accept larger packet, appl may
	     * send larger thereby calling for increase in sizeof recv_msg
	     * Now CLD has to pass on this new msg to server calling for
	     * increase in send_msg
	     */
	    free(send_msg);
	    free(recv_msg);
	    
	    send_msg = (char *) malloc(MAX_DHCP_MSG + APPL_DATA_OVERHEAD);
	    recv_msg = (char *) malloc(MAX_DHCP_MSG + APPL_DATA_OVERHEAD);
	    /* Imp: You need to change the size of buffer for init list */
	  }
	  break;
	}
      }/* for t_init = */
    }
    break;

  case DHCP_RECONFIGURE:
    {
      RECONFIGURE rec; 

      size = sizeof(rec);
      if(len < size){
	printf("Invalid DHCP_RECONFIGURE from server. Ignoring...\n");
	return;
      }
      memcpy(&rec, msg, size);
    }
    break;

  case DHCP_RECONFIGURE_INIT:
    {
      RECONFIGURE_INIT rec_init;

      size = sizeof(rec_init);
      if(len < size){
	printf("Invalid DHCP_RECONFIGURE_INIT from server. Ignoring...\n");
	return;
      }
      memcpy(&rec_init, msg, size);

    }
    break;

  default:
#ifdef DEBUG
    printf("Invalid message type received from server\n");
#endif
    break;

  }
}
