void copy_server_solicit_info(SERVER_SOLICIT_INFO *dst, SERVER_SOLICIT_INFO *src){
  SUBNET_PREFIX_INFO **destination, *source;

  if(!dst){

#ifdef DEBUG
    printf("Can't copy into NULL destination\n");
#endif

    return;
  }

  if(!src){

#ifdef DEBUG
    printf("Can't copy from NULL source\n");
#endif

    return;
  }

  dst->relay_addr     = src->relay_addr;
  dst->server_addr    = src->server_addr;
  dst->preference     = src->preference;
  dst->no_of_prefixes = src->no_of_prefixes;

  for(destination = &dst->subnet_prefix_info_head, source = src->subnet_prefix_info_head;
      source;
      destination = &(*destination)->next, source = source->next){
    if(!*destination){
      *destination = (SUBNET_PREFIX_INFO *) malloc(sizeof(SUBNET_PREFIX_INFO));
      bzero(*destination, sizeof(SUBNET_PREFIX_INFO));
    }
    
    memcpy((*destination)->prefix_len_octets,
	   source->prefix_len_octets,
	   sizeof(source->prefix_len_octets));

  }
}

void clear_server_solicit_list(SERVER_SOLICIT_INFO *sol_list_head){
  SERVER_SOLICIT_INFO *temp_serv_sol;

  for(temp_serv_sol = sol_list_head;
      temp_serv_sol;
      temp_serv_sol = temp_serv_sol->next
      ){
    bzero((char *) &temp_serv_sol->server_addr, sizeof(temp_serv_sol->server_addr));
  }
}

void copy_server_solicit_list(SERVER_SOLICIT_INFO **dst, SERVER_SOLICIT_INFO *src){
  SERVER_SOLICIT_INFO *temp_serv_sol_info, **t;

  clear_server_solicit_list(*dst);

  for(temp_serv_sol_info = src, t = dst;
      temp_serv_sol_info;
      temp_serv_sol_info = temp_serv_sol_info->next, t = &(*t)->next){
    
    if(!(*t)){
	*t = (SERVER_SOLICIT_INFO *) malloc(sizeof(SERVER_SOLICIT_INFO));
	bzero(*t, sizeof(SERVER_SOLICIT_INFO));
    }
    
    copy_server_solicit_info(*t, temp_serv_sol_info);
  }
  
}
