#ifndef JUNK
#define JUNK
#endif

void send_adv_to_appl(FD_INIT_LIST *temp_init){
  SERVER_SOLICIT_INFO   *temp_serv_sol_info, max_preference_entry;
  HEADER_CLIENTD_PACKET  header;
  SUBNET_PREFIX_INFO    *temp_subnet_prefix_info;
  int                    len = 0, size, i = 0, no_of_servers = 0, padding_len;
  int                    max_preference = -1;
  char                   padding[3];
  PREF_NO_OF_PREFIXES    pnp[MAX_SERVERS];
  SOLICIT_DATA           sol_data;

  temp_init->request_pending = 0;
  temp_init->adv_received    = 0;
  temp_init->no_of_attempts  = 0;

  bzero(padding, 3);
  memcpy(&sol_data, temp_init->msg_data, sizeof(sol_data));
  header.msg_type   = DHCP_ADVERTISE;
  header.error      = 0;
  header.pid        = htons(temp_init->pid);
  header.request_no = htonl(temp_init->request_no);

  iov[0].iov_base   = (char *)&header;
  iov[0].iov_len    = len = sizeof(header);
  i = 1;

  for(temp_serv_sol_info = temp_init->sol_list_head;
      temp_serv_sol_info;
      temp_serv_sol_info = temp_serv_sol_info->next){
 
#ifdef JUNK
    printf("...................%u\n", temp_serv_sol_info->preference);
#endif

    if(i > SIZE_OF_IOVEC - 3)
      err_dump("Insufficient size of iovec\n");
    /* Including relay address in reply */
    iov[i].iov_base = (char *)& temp_serv_sol_info->relay_addr;
    iov[i].iov_len  = sizeof(temp_serv_sol_info->relay_addr);
    len            += iov[i].iov_len;
    i++;

    /* Including server address in reply */
    iov[i].iov_base = (char *)& temp_serv_sol_info->server_addr;
    iov[i].iov_len  = sizeof(temp_serv_sol_info->server_addr);
    len            += iov[i].iov_len;
    i++;

    /* Including preference and no of prefixes info in reply */
    pnp[no_of_servers].reserved       = 0;
    pnp[no_of_servers].no_of_prefixes = temp_serv_sol_info->no_of_prefixes;
    pnp[no_of_servers].preference     = temp_serv_sol_info->preference;

#ifdef JUNK
    printf("*******************[%u]%u\n", no_of_servers, pnp[no_of_servers].preference);
#endif
    iov[i].iov_base = (char *)& pnp[no_of_servers];
    iov[i].iov_len  = sizeof(pnp[no_of_servers]);
    len            += iov[i].iov_len;
    i++;
    no_of_servers++;

    if(sol_data.p == 1){
      /* Including prefixes info in reply */
      for(temp_subnet_prefix_info = temp_serv_sol_info->subnet_prefix_info_head;
	  temp_subnet_prefix_info;
	  temp_subnet_prefix_info = temp_subnet_prefix_info->next){

	if(i >= SIZE_OF_IOVEC)
	  err_dump("Insufficient size of iovec\n");
	
	iov[i].iov_base = & temp_subnet_prefix_info->prefix_len_octets[0];
	/* Length of this data must be 1(for prefix-len) + Ceiling of prefix_len/8 bec its in bits */
	iov[i].iov_len  = 1 + (temp_subnet_prefix_info->prefix_len_octets[0] + 7)/8;
	len            += iov[i].iov_len;
	i++;
      }

      /* Now we have to add padding if needed */
      if((padding_len = (len % SIZE_OF_LONG)) != 0){

	if(i >= SIZE_OF_IOVEC)
	  err_dump("Insufficient size of iovec\n");

	iov[i].iov_base = padding;
	iov[i].iov_len  = SIZE_OF_LONG - padding_len;
	len            += iov[i].iov_len;
	i++;
      }
    }
    /* If only one reply was asked for break out of loop */
    if(sol_data.a == 0)
      break;
  }
  printf("~~~~~~~~~~~~~~~~~~~~~~%u %u %u\n", no_of_servers, pnp[0].preference, pnp[1].preference);
  if(writev(temp_init->tcp_fd, &iov[0], i) != len){
    printf("Error in sending reply to appl with pid = %u\n", temp_init->pid);
  }

  /* Copy the solicit list into interface's solicit list if this one is new */

  printf("((((((((((((((((**))))))))))))))))interface adv time = %u %u if_solicit_id = %u\n",
	temp_init->interface->advertise_time.tv_sec, temp_init->interface->advertise_time.tv_usec,
	 temp_init->interface->solicit_id);

  printf("((((((((((((((((***))))))))))))))))appl adv time = %u %u\n",
	 temp_init->advertise_time.tv_sec, temp_init->advertise_time.tv_usec);

  if(DIFF_IN_MS(temp_init->advertise_time, temp_init->interface->advertise_time) > 0){
    printf("diff > 0\n");
    temp_init->interface->advertise_time = temp_init->advertise_time;
    copy_server_solicit_list(& temp_init->interface->sol_list_head,
			     temp_init->sol_list_head);
  }
  printf("((((((((((((((((**))))))))))))))))interface adv time = %u %u if_solicit_id = %u\n",
	temp_init->interface->advertise_time.tv_sec, temp_init->interface->advertise_time.tv_usec,
	 temp_init->interface->solicit_id);
  printf("((((((((((((((((***))))))))))))))))appl adv time = %u %u\n",
	 temp_init->advertise_time.tv_sec, temp_init->advertise_time.tv_usec);
}


