/*
 * Error codes used are defined in ../lib/error.h
 * 1 : INVALID_MESSAGE_FORMAT
 * 2 : MESSAGE_FIELD_INVALID
 * 3 : server didn't respond even after max attempts.
 */
void send_error(FD_INIT_LIST *appl, uint8_t error_code){
  HEADER_CLIENTD_PACKET header;

  header.error      = error_code;
  header.msg_type   = appl->msg_type;
  header.pid        = htons(appl->pid);
  header.request_no = htonl(appl->request_no);

  if(send(appl->tcp_fd, &header, sizeof(header), 0) != sizeof(header))
    err_dump("Error in send. Exiting...");
}
