typedef struct{

  uint8_t          msg_type                    ;
  uint8_t          c_p_reserved                ;
  uint16_t         prefix_len_solicit_id       ;

  struct in6_addr  client_link_local_addr      ;
  struct in6_addr  relay_addr                  ;

} SOLICIT;

typedef struct{
  uint8_t          msg_type                     ;
  uint8_t          reserved_solicit_id[2]       ;
  uint8_t          preference                   ;
  
  struct in6_addr  client_link_local_addr       ;
  struct in6_addr  relay_addr                   ;
  struct in6_addr  server_addr                  ;
  /*
   * extensions if any follow
   */

} ADVERTISE;

typedef struct{
  uint8_t          msg_type                     ;
  uint8_t          c_r_reserved                 ;
  uint16_t         transaction_id               ;

  struct in6_addr  client_link_local_addr       ;
  struct in6_addr  relay_addr                   ;
  struct in6_addr  server_addr                  ;
  /*
   * extensions if any follow
   */

} REQUEST;

typedef struct{

  uint8_t          msg_type                     ;
  uint8_t          r_status                     ;
  uint16_t         transaction_id               ;

  struct in6_addr  client_link_local_addr       ;

  /* struct in6_addr  relay_addr if r = 1  */ 
  /*
   * extensions if any follow
   */

} REPLY;

typedef struct{

  uint8_t          msg_type                     ;
  uint8_t          r_reserved                   ;
  uint16_t         transaction_id               ;

  struct in6_addr  client_link_local_addr       ;
  struct in6_addr  server_addr                  ;
  struct in6_addr  x_addr                       ;
  /*
   * extensions if any follow
   */

} RELEASE;

typedef struct{

  uint8_t          msg_type                     ;
  uint8_t          reserved                     ;
  uint16_t         transaction_id               ;

  struct in6_addr  server_addr                  ;
  /*
   * extensions if any follow
   */

} RECONFIGURE;

typedef struct{

  uint8_t          msg_type                     ;
  uint8_t          r_status                     ;
  uint16_t         transaction_id               ;

  struct in6_addr  client_link_local_addr       ;
  struct in6_addr  server_addr                  ;

} RECONFIGURE_REPLY;

typedef struct{

  uint8_t          msg_type                     ;
  uint8_t          reserved                     ;
  uint16_t         transaction_id               ;

  struct in6_addr  server_addr                  ;
  /*
   * extensions if any follow
   */

} RECONFIGURE_INIT;

/*
main(){
  
  printf("sizeof SOLICIT = %u\n", sizeof(SOLICIT));
  printf("sizeof ADVERTISE = %u\n", sizeof(ADVERTISE));
  printf("sizeof REQUEST = %u\n", sizeof(REQUEST));
  printf("sizeof REPLY = %u\n", sizeof(REPLY));
  printf("sizeof RELEASE = %u\n", sizeof(RELEASE));
  printf("sizeof RECONFIGURE = %u\n", sizeof(RECONFIGURE));
  printf("sizeof RECONFIGURE_REPLY = %u\n", sizeof(RECONFIGURE_REPLY));
  printf("sizeof RECONFIGURE_INIT = %u\n", sizeof(RECONFIGURE_INIT));
}
*/
