/* 
 * GET_BITS_LOW gets lower order N bits of x
 * GET_BITS_HIGH gets higher order bits from S bit field x
 * GET_BITS_MIDDLE gets N bits from position PL from lower order.
 *    ex. To get bits 6 and 5 (10) of 01101101 PL = 6, N = 2
 * 
 * 
 */

# define GET_ADV_SOLICIT_ID(x)     ( (((x)[0] & 1) << 8) + (x)[1] )
# define GET_STATUS(x)             ( (x) & 0x7f )
# define GET_R(x)                  ( ((x) & 0x80) >> 7 )
# define GET_BITS_LOW(x, N)        ( (x) & ((1 << N) - 1) )
# define GET_BITS_HIGH(x, N, S)    ( ((x) - ((x) & ((1 << (S - N)) - 1))) >> (S - N) )
# define GET_BITS_MIDDLE(x, PL, N) ( ((x) & ((1 << PL) - (1 << (PL - N)))) >> (PL - N) )


# define SET_ADV_SOLICIT_ID(x, y) {                                                   \
           (x)[0] = ((y) >> 8) & 1;                                                   \
           (x)[1] = (y) & 0xff;                                                       \
}

/* 
 * Note that in the above macro Our assignment is such that 
 * reserved automatically becomes zero. In true sense it sets
 * not only solicit id but reserved to 0 as well.
 */


# define SET_STATUS(x, y) {                                                           \
           (x) = ((x) & 0x80) + ( (y) & 0x7f );                                       \
}


# define SET_R(x, y) {                                                                \
           (x) = ((x) & 0x7f) + (((y) & 1) << 7);                                     \
}

# define SET_BITS_LOW(x, y, N) {                                                      \
           (x) = (x) - ((x) & ((1 << N) - 1)) + ((y) & ((1 << N) - 1));              \
}

# define SET_BITS_HIGH(x, y, N, S) {                                                  \
           (x) = ((x) & ((1 << (S - N)) - 1)) + (((y) & ((1 << N) - 1)) << (S - N));  \
}

# define SET_BITS_MIDDLE(x, y, PL, N) {                                               \
           (x) = (x) - ((x) & ((1 << PL) - (1 << (PL - N))));                         \
           (x) = (x) + (((y) & ((1 << N) - 1)) << (PL - N));                          \
}
