# include "solicit_params.h"

int solicit(uint8_t deallocate_all_releasable_resources, uint8_t subnet_prefix){
  
  struct solicit_params cp;

  printf("sizeof cp = %u header = %u\n", sizeof(cp), sizeof(header));
  getchar();

  if(deallocate_all_releasable_resources != 0 ||
     deallocate_all_releasable_resources != 1){
#ifdef DEBUG
    printf("Invalid value for \"deallocate_all_releasable_resources\" bit.\n");
#endif
    return 0;
  } 
  
  if(subnet_prefix != 0 ||
     subnet_prefix != 1){
#ifdef DEBUG
    printf("Invalid value for \"subnet_prefix bit\".\n");
#endif
    return 0;
  }

  header.msg_type    = 1;
  header.pid         = pid = getpid();
  header.request_no  = request_no++;

#ifdef DEBUG
  printf("Sending to client daemon: \nmsg_type   = %u \npid        = %u \nrequest_no = %u\n",
	 header.msg_type,
	 header.pid,
	 header.request_no);
#endif

  temp               = (uint32_t *) &header;
  *temp              = htonl(*temp);
  header.request_no  = htonl(header.request_no);

  n                  = sizeof(header);
  memcpy(send_msg, &header, n);

  cp.c               = deallocate_all_releasable_resources;
  cp.p               = subnet_prefix;

#ifdef DEBUG
  printf("c          = %u\n", cp.c);
  printf("p          = %u\n", cp.p);
#endif

  temp               = (uint32_t *) &cp;
  *temp              = htonl(*temp);

  memcpy((send_msg + n), &cp, sizeof(cp));
  n                 += sizeof(cp);

  if(send(sockfd, send_msg, n, 0) != n){  //, (struct sockaddr *) &clientd_sockaddr, sizeof(clientd_sockaddr)
    printf("Error in sending initialization message to client daemon. Returning...\n");
    return 0;
  }

  n                  = recv(sockfd, recv_msg, MAX_MSG_SIZE, 0);
  if(n < 0){
    printf("Error in recv. Exiting...");
    return 0;
  }

  memcpy(&header, recv_msg, sizeof(header));
  temp               = (uint32_t *) &header;
  *temp              = ntohl(*temp);
  header.request_no  = ntohl(header.request_no);
  

#ifdef DEBUG
  printf("Reply from client daemon\n\n");
  printf("msg_type   = %u\n", header.msg_type);
  printf("pid        = %u\n", header.pid);
  printf("request_no = %u\n", header.request_no);
#endif
    
  return 1;
}
