typedef struct subnet_prefix_info  SUBNET_PREFIX_INFO;
typedef struct server_solicit_info SERVER_SOLICIT_INFO;

struct subnet_prefix_info{

  SUBNET_PREFIX_INFO  *next;                       /* Next prefix managed by same server    */
  uint8_t              prefix_len_octets[17];      /* Subnet Prefix length and Octets       */
  /*
   * Note prefix_len_octets[0] = prefix len. This has been done for ease of copying while
   * replying back to application.
   */
};

struct server_solicit_info{
  
  /*
   * Note: server_addr == 0 or :: means invalid entry.
   */
  SERVER_SOLICIT_INFO *next;                       /* Pointer to next server in solicit list*/
  struct in6_addr      relay_addr;                 /* Relay's address                       */
  struct in6_addr      server_addr;                /* Server's address                      */
  uint8_t              preference;                 /* Preference sent by server             */
  uint8_t              no_of_prefixes;             /* Size of following list                */
  SUBNET_PREFIX_INFO  *subnet_prefix_info_head;    /* List of prefixes the server manages   */

};
