int has_been_leased(struct in6_addr *ip_addr, LEASE *t_lease_list_head) {
  LEASE *temp_lease;

  for(temp_lease = lease_list_head; temp_lease; temp_lease = temp_lease->next) {
    if(/*IN6_ARE_ADDR_EQUAL(&lease->leased_to, temp_lease->leased_to)) {
	 
      if(lease->onlink == 1 && temp_lease->onlink == 1 &&
      strcmp((lease->un).interface_name, ((temp_lease->un).interface_name)) == 0 &&
	 IN6_ARE_ADDR_EQUAL(ip_addr, &temp_lease->ip_addr))
	return 1;

      else if(lease->onlink == 0 && temp_lease->onlink == 0 &&
	      (lease->un).st.subnet_prefix_len == (temp_lease->un).st.subnet_prefix_len &&
	      IN6_ARE_PREFIXES_EQUAL(&(lease->un).st.subnet_prefix,
	      &(temp_lease->un).st.subnet_prefix) &&*/
       IN6_ARE_ADDR_EQUAL(ip_addr, &temp_lease->ip_addr))
      return 1;
      
  }
  for(temp_lease = t_lease_list_head; temp_lease; temp_lease = temp_lease->next) {
    if(IN6_ARE_ADDR_EQUAL(ip_addr, &temp_lease->ip_addr))
      return 1;
      
  }
  return 0;
}

int compare(struct in6_addr *a1, struct in6_addr *a2) {
  int i, size = sizeof(*a1);

  for(i = 0; i < size; i++) {
    if(a1->s6_addr8[i] == a2->s6_addr8[i])
      continue;
    return (a1->s6_addr8[i] - a2->s6_addr8[i]);
  }
  return 0;
}

void increment_in6_addr(struct in6_addr *addr) {
  int i, temp;
  int max = 255;
  char name[64];

  for(i = sizeof(*addr) - 1; i >= 0; i--) {
    temp = addr->s6_addr8[i] + 1;
    if(temp <= max) {
      addr->s6_addr8[i] = temp;
      return;
    }
    addr->s6_addr8[i] = 1;
  }
}

# define IN6_IS_INTERFACE_ID_ZERO(x) (((x)->s6_addr32[2] == 0) && ((x)->s6_addr32[3] == 0))

struct in6_addr *find_unleased_addr_in_range(RANGE *range,
					     LEASE *t_lease_list_head){
  struct in6_addr temp_addr, *result;

  for(temp_addr = range->start; compare(&temp_addr, &range->end) <= 0;
      increment_in6_addr(&temp_addr)) {
    if(!has_been_leased(&temp_addr, t_lease_list_head)) {
      result = (struct in6_addr *) malloc(sizeof(struct in6_addr));
      if(!result)
	errx(1, "Insufficient memory. Exiting...\n");
      *result = temp_addr;
      return result;
    }
  }
  return NULL;
}

int renewal_allowed(LEASE *lease, uint8_t expired) {
  return 1;
}

struct in6_addr *find_unleased_addr_in_range_with_prefix(RANGE *range,
							 struct in6_addr *prefix,
							 uint8_t prefix_len,
							 LEASE *t_lease_list_head){
  struct in6_addr temp_addr, *result;

  for(temp_addr = range->start; compare(&temp_addr, &range->end) <= 0;
      increment_in6_addr(&temp_addr)) {
    if(IN6_ARE_PREFIXES_EQUAL(&temp_addr, prefix, prefix_len) &&
       !has_been_leased(&temp_addr, t_lease_list_head)) {
      result = (struct in6_addr *) malloc(sizeof(struct in6_addr));
      if(!result)
	errx(1, "Insufficient memory. Exiting...\n");
      *result = temp_addr;
      return result;
    }
  }
  return NULL;
}

int get_new_addr_by_scope(SUBNET *subnet, INTERFACE *interface,
			  LEASE *lease, uint8_t A, uint8_t P,
			  LEASE *t_lease_list_head){
  /* Scope is contained in scope field of lease */
  /* Return values -> 0: Success, 1: Failure */
  struct in6_addr *temp_addr = NULL;
  S_IN6_ADDR_LIST *temp_iaddr_list;
  RANGE           *temp_range;
  uint8_t          scope_available = 0, flag = 0;
  HOST            *host;

  if(lease->onlink) {
    host = find_on_link_host(interface, &lease->leased_to);
  }
  else {
    host = find_off_link_host(subnet, &lease->leased_to);
  }

  if(host) {
    /* Specific address assignment */
    for(temp_iaddr_list = host->fixed_addr_list_head; temp_iaddr_list;
	temp_iaddr_list = temp_iaddr_list->next) {

      if((A && !temp_iaddr_list->dns_update_A_allowed) ||
	 (P && !temp_iaddr_list->dns_update_P_allowed))
	/* We can't lease an address where dns update is not allowed and client is asking
	 * for update.
	 */
	continue;

      if(!has_been_leased(&temp_iaddr_list->ip_addr, t_lease_list_head) &&
	 temp_iaddr_list->max_preferred_lifetime >= lease->preferred_lifetime &&
	 temp_iaddr_list->max_valid_lifetime >= lease->valid_lifetime) {
	//temp_addr                 = &temp_iaddr_list->ip_addr;

	if(lease->scope != 0) {
	  /* No Don't care */
	  scope_available = (lease->scope == temp_iaddr_list->scope);
	  flag            = 1;
	  if(!scope_available)
	    continue;
	}
	lease->scope              = temp_iaddr_list->scope;
	lease->ip_addr            = temp_iaddr_list->ip_addr;
	lease->ip_addr_prefix_len = temp_iaddr_list->prefix_len;
	
	if(lease->preferred_lifetime == 0)
	  lease->preferred_lifetime = temp_iaddr_list->default_preferred_lifetime;
	
	if(lease->valid_lifetime == 0)
	  lease->valid_lifetime = temp_iaddr_list->default_valid_lifetime;
	
	lease->default_preferred_lifetime = temp_iaddr_list->default_preferred_lifetime;
	lease->default_valid_lifetime     = temp_iaddr_list->default_valid_lifetime;
	lease->max_preferred_lifetime     = temp_iaddr_list->max_preferred_lifetime;
	lease->max_valid_lifetime         = temp_iaddr_list->max_valid_lifetime;
	lease->dns_update_A_allowed       = temp_iaddr_list->dns_update_A_allowed;
	lease->dns_update_P_allowed       = temp_iaddr_list->dns_update_P_allowed;
	return REQUEST_GRANTED_NO_ERRORS;
      }
    }
    /* I we are here either there is no fixed addr or all have already been leased
     * Now code would be similar to any address assignment from host's range declaration or
     * subnet/interface range declaration in which the host appears.
     */
    if(host->range_list_head) {
      /* If there is range declaration inside host we must use it */
      for(temp_range = host->range_list_head; temp_range; temp_range = temp_range->next) {

	if((A && !temp_range->dns_update_A_allowed) ||
	   (P && !temp_range->dns_update_P_allowed))
	  /* We can't lease an address where dns update is not allowed and client is
	   * asking for update.
	   */
	  continue;

	if(temp_range->max_preferred_lifetime >= lease->preferred_lifetime &&
	   temp_range->max_valid_lifetime >= lease->valid_lifetime) {

	  temp_addr = find_unleased_addr_in_range(temp_range, t_lease_list_head);
	  if(temp_addr) {

	    if(lease->scope != 0) {
	      scope_available         = (temp_range->scope == lease->scope);
	      flag                    = 1;
	      if(!scope_available)
		continue;
	    }
	    
	    lease->scope              = temp_range->scope;
	    lease->ip_addr            = *temp_addr;
	    lease->ip_addr_prefix_len = temp_range->prefix_len;
	    
	    if(lease->preferred_lifetime == 0)
	      lease->preferred_lifetime = temp_range->default_preferred_lifetime;
	    
	    if(lease->valid_lifetime == 0)
	      lease->valid_lifetime = temp_range->default_valid_lifetime;
	    
	    lease->default_preferred_lifetime = temp_range->default_preferred_lifetime;
	    lease->default_valid_lifetime     = temp_range->default_valid_lifetime;
	    lease->max_preferred_lifetime     = temp_range->max_preferred_lifetime;
	    lease->max_valid_lifetime         = temp_range->max_valid_lifetime;
	    lease->dns_update_A_allowed       = temp_range->dns_update_A_allowed;
	    lease->dns_update_P_allowed       = temp_range->dns_update_P_allowed;
	    free(temp_addr);
	    return REQUEST_GRANTED_NO_ERRORS;
	  }
	}
      }
    }
    else {
      /* If there is no range declaration inside host we must use subnet/interface range */
      if(lease->onlink)
	temp_range = interface->range_list_head;
      else
	temp_range = subnet->range_list_head;
      
      for(; temp_range; temp_range = temp_range->next) {

	if((A && !temp_range->dns_update_A_allowed) ||
	   (P && !temp_range->dns_update_P_allowed))
	  /* We can't lease an address where dns update is not allowed and client is
	   * asking for update.
	   */
	  continue;

	if(temp_range->max_preferred_lifetime >= lease->preferred_lifetime &&
	   temp_range->max_valid_lifetime >= lease->valid_lifetime) {

	  temp_addr = find_unleased_addr_in_range(temp_range, t_lease_list_head);
	  if(temp_addr) {
	    
	    if(lease->scope != 0) {
	      scope_available         = (temp_range->scope == lease->scope);
	      flag                    = 1;
	      if(!scope_available)
		continue;
	    }
	    
	    lease->scope              = temp_range->scope;
	    lease->ip_addr            = *temp_addr;
	    lease->ip_addr_prefix_len = temp_range->prefix_len;
	    
	    if(lease->preferred_lifetime == 0)
	      lease->preferred_lifetime = temp_range->default_preferred_lifetime;
	    
	    if(lease->valid_lifetime == 0)
	      lease->valid_lifetime = temp_range->default_valid_lifetime;
	    
	    lease->default_preferred_lifetime = temp_range->default_preferred_lifetime;
	    lease->default_valid_lifetime     = temp_range->default_valid_lifetime;
	    lease->max_preferred_lifetime     = temp_range->max_preferred_lifetime;
	    lease->max_valid_lifetime         = temp_range->max_valid_lifetime;
	    lease->dns_update_A_allowed       = temp_range->dns_update_A_allowed;
	    lease->dns_update_P_allowed       = temp_range->dns_update_P_allowed;
	    free(temp_addr);
	    return REQUEST_GRANTED_NO_ERRORS;
	  }
	}
      }
      
    }
    /* If we are here it means there is no address to lease in range list of host or
     * its subnet/interface.
     */
    if(flag)
      return IP_ADDR_SCOPE_UNAVAILABLE;
    return REQUESTED_IP_ADDR_UNAVAILABLE; /* I don't think this is a good return value but
					     there is no other value which is good enough */
  }
  else {
    /* any address can be assigned */
    if(lease->onlink) {
      temp_range = interface->range_list_head;
    }
    else {
      temp_range = subnet->range_list_head;
    }

    for(; temp_range; temp_range = temp_range->next) {

      if((A && !temp_range->dns_update_A_allowed) ||
	 (P && !temp_range->dns_update_P_allowed))
	/* We can't lease an address where dns update is not allowed and client is
	 * asking for update.
	 */
	continue;
      
      if(temp_range->max_preferred_lifetime >= lease->preferred_lifetime &&
	 temp_range->max_valid_lifetime >= lease->valid_lifetime) {
	/*
	if(!lease->onlink &&
	   !IN6_ARE_PREFIXES_EQUAL(temp_range->start, (lease->un).st.subnet_prefix,
				   (lease->un).st.subnet_prefix_len))
	  // For off link clients desired prefix must be made available
	  continue;
	*/
	temp_addr = find_unleased_addr_in_range(temp_range, t_lease_list_head);
	if(temp_addr) {
	    
	  if(lease->scope != 0) {
	    scope_available         = (temp_range->scope == lease->scope);
	    flag                    = 1;
	    if(!scope_available)
	      continue;
	  }
	  
	  lease->scope              = temp_range->scope;
	  lease->ip_addr            = *temp_addr;
	  lease->ip_addr_prefix_len = temp_range->prefix_len;

	  if(lease->preferred_lifetime == 0)
	    lease->preferred_lifetime = temp_range->default_preferred_lifetime;

	  if(lease->valid_lifetime == 0)
	    lease->valid_lifetime = temp_range->default_valid_lifetime;

	  lease->default_preferred_lifetime = temp_range->default_preferred_lifetime;
	  lease->default_valid_lifetime     = temp_range->default_valid_lifetime;
	  lease->max_preferred_lifetime     = temp_range->max_preferred_lifetime;
	  lease->max_valid_lifetime         = temp_range->max_valid_lifetime;
	  lease->dns_update_A_allowed       = temp_range->dns_update_A_allowed;
	  lease->dns_update_P_allowed       = temp_range->dns_update_P_allowed;
	  free(temp_addr);
	  return REQUEST_GRANTED_NO_ERRORS;
	}
      }
    }
  }
  if(flag)
    return IP_ADDR_SCOPE_UNAVAILABLE;
  return REQUESTED_IP_ADDR_UNAVAILABLE; /* I don't think this is a good return value but
					   there is no other value which is good enough */
}

int get_specific_addr(SUBNET *subnet, INTERFACE *interface,
		      LEASE *lease, uint8_t A, uint8_t P,
		      LEASE *t_lease_list_head) {
  /* This function gets the specific address lease->ip_addr if interface id is present
   * else it gets an address on specified network.
   * The network desired is specified by ip_addr & ip_addr_prefix_len fields of lease.
   * Imp: Set lease->scope, ip_addr_prefix_len
   * Scope field passed by client in the ext is not used in this case.
   * Note that the function is called only when lease->ip_addr hasn't been leased to this
   * client or anybody else.
   */
  struct in6_addr *temp_addr = NULL;
  S_IN6_ADDR_LIST *temp_iaddr_list;
  RANGE           *temp_range;
  uint8_t          scope_available = 0, flag = 0;
  HOST            *host;
  uint8_t          prefix_len;

  prefix_len = (IN6_IS_INTERFACE_ID_ZERO(&lease->ip_addr)) ? lease->ip_addr_prefix_len : 128;
  printf("prefix-len %u\n", prefix_len);
  /* The prefix_len variable above denotes the length we must match. If interface
   * id is zero we look for only 64 bits while we look for whole match if it isn't
   * zero
   */
  /* Imp: Where is prefix_len passed by client used if interface id is 64 bits.
   * There are only two cases: (a) interface-id present in which case prefix is 128 bits,
   * and (b) interface id absent in which case subnet prefis is 64. Only thing which I can do
   * is to to use the prefxi_len the client has passed as a prefxi_len for subnet in (b).
   */
  /*
    if(!interface_id_zero) {
      //* We will search both fixed-addr-list and range declarations of host
       //* If interface_id is zero we would search only range declarations
    }
  */

  if(lease->onlink) {
    host = find_on_link_host(interface, &lease->leased_to);
  }
  else {
    host = find_off_link_host(subnet, &lease->leased_to);
  }

  if(host) {
    for(temp_iaddr_list = host->fixed_addr_list_head; temp_iaddr_list;
	temp_iaddr_list = temp_iaddr_list->next) {
      
      if((A && !temp_iaddr_list->dns_update_A_allowed) ||
	 (P && !temp_iaddr_list->dns_update_P_allowed))
	/* We can't lease an address where dns update is not allowed and client is asking
	 * for update.
	 */
	continue;

      if(IN6_ARE_PREFIXES_EQUAL(&temp_iaddr_list->ip_addr, &lease->ip_addr, prefix_len) &&
	 !has_been_leased(&temp_iaddr_list->ip_addr, t_lease_list_head) &&
	 temp_iaddr_list->max_preferred_lifetime >= lease->preferred_lifetime &&
	 temp_iaddr_list->max_valid_lifetime >= lease->valid_lifetime) {
	//temp_addr                 = &temp_iaddr_list->ip_addr;

	/* If you want to check scope uncomment this comment
	if(lease->scope != 0) {
	  // No don't care
	  scope_available = (lease->scope == temp_iaddr_list->scope);
	  flag            = 1;
	  if(!scope_available)
	    continue;
	}
	*/
	lease->scope              = temp_iaddr_list->scope;
	lease->ip_addr            = temp_iaddr_list->ip_addr;
	lease->ip_addr_prefix_len = temp_iaddr_list->prefix_len;
	
	if(lease->preferred_lifetime == 0)
	  lease->preferred_lifetime = temp_iaddr_list->default_preferred_lifetime;
	
	if(lease->valid_lifetime == 0)
	  lease->valid_lifetime = temp_iaddr_list->default_valid_lifetime;
	
	lease->default_preferred_lifetime = temp_iaddr_list->default_preferred_lifetime;
	lease->default_valid_lifetime     = temp_iaddr_list->default_valid_lifetime;
	lease->max_preferred_lifetime     = temp_iaddr_list->max_preferred_lifetime;
	lease->max_valid_lifetime         = temp_iaddr_list->max_valid_lifetime;
	lease->dns_update_A_allowed       = temp_iaddr_list->dns_update_A_allowed;
	lease->dns_update_P_allowed       = temp_iaddr_list->dns_update_P_allowed;
	return REQUEST_GRANTED_NO_ERRORS;
      }
    }


    
    /* I we are here either there is no fixed addr or all have already been leased
     * Now code would be similar to any address assignment from host's range declaration or
     * subnet/interface range declaration in which the host appears.
     */
    if(host->range_list_head) {
      /* If there is range declaration inside host we must use it */
      for(temp_range = host->range_list_head; temp_range; temp_range = temp_range->next) {

	if((A && !temp_range->dns_update_A_allowed) ||
	   (P && !temp_range->dns_update_P_allowed))
	  /* We can't lease an address where dns update is not allowed and client is
	   * asking for update.
	   */
	  continue;

	if(temp_range->max_preferred_lifetime >= lease->preferred_lifetime &&
	   temp_range->max_valid_lifetime >= lease->valid_lifetime) {

	  temp_addr = find_unleased_addr_in_range_with_prefix(temp_range, &lease->ip_addr,
							      prefix_len, t_lease_list_head);
	  if(temp_addr) {
	    
	    /* If you want to check scope uncomment this comment
	    if(lease->scope != 0) {
	      scope_available         = (temp_range->scope == lease->scope);
	      flag                    = 1;
	      if(!scope_available)
		continue;
	    }
	    */
	    lease->scope              = temp_range->scope;
	    lease->ip_addr            = *temp_addr;
	    lease->ip_addr_prefix_len = temp_range->prefix_len;
	    
	    if(lease->preferred_lifetime == 0)
	      lease->preferred_lifetime = temp_range->default_preferred_lifetime;
	    
	    if(lease->valid_lifetime == 0)
	      lease->valid_lifetime = temp_range->default_valid_lifetime;
	    
	    lease->default_preferred_lifetime = temp_range->default_preferred_lifetime;
	    lease->default_valid_lifetime     = temp_range->default_valid_lifetime;
	    lease->max_preferred_lifetime     = temp_range->max_preferred_lifetime;
	    lease->max_valid_lifetime         = temp_range->max_valid_lifetime;
	    lease->dns_update_A_allowed       = temp_range->dns_update_A_allowed;
	    lease->dns_update_P_allowed       = temp_range->dns_update_P_allowed;
	    free(temp_addr);
	    return REQUEST_GRANTED_NO_ERRORS;
	  }
	}
      }
    }
    else {
      /* If there is no range declaration inside host we must use subnet/interface range */
      if(lease->onlink)
	temp_range = interface->range_list_head;
      else
	temp_range = subnet->range_list_head;
      
      for(; temp_range; temp_range = temp_range->next) {

	if((A && !temp_range->dns_update_A_allowed) ||
	   (P && !temp_range->dns_update_P_allowed))
	  /* We can't lease an address where dns update is not allowed and client is
	   * asking for update.
	   */
	  continue;

	if(temp_range->max_preferred_lifetime >= lease->preferred_lifetime &&
	   temp_range->max_valid_lifetime >= lease->valid_lifetime) {
	  
	  temp_addr = find_unleased_addr_in_range_with_prefix(temp_range, &lease->ip_addr,
							      prefix_len, t_lease_list_head);
	  if(temp_addr) {
	    
	    /* If you want to check scope uncomment this comment
	    if(lease->scope != 0) {
	      scope_available         = (temp_range->scope == lease->scope);
	      flag                    = 1;
	      if(!scope_available)
		continue;
	    }
	    */
	    lease->scope              = temp_range->scope;
	    lease->ip_addr            = *temp_addr;
	    lease->ip_addr_prefix_len = temp_range->prefix_len;
	    
	    if(lease->preferred_lifetime == 0)
	      lease->preferred_lifetime = temp_range->default_preferred_lifetime;
	    
	    if(lease->valid_lifetime == 0)
	      lease->valid_lifetime = temp_range->default_valid_lifetime;
	    
	    lease->default_preferred_lifetime = temp_range->default_preferred_lifetime;
	    lease->default_valid_lifetime     = temp_range->default_valid_lifetime;
	    lease->max_preferred_lifetime     = temp_range->max_preferred_lifetime;
	    lease->max_valid_lifetime         = temp_range->max_valid_lifetime;
	    lease->dns_update_A_allowed       = temp_range->dns_update_A_allowed;
	    lease->dns_update_P_allowed       = temp_range->dns_update_P_allowed;
	    free(temp_addr);
	    return REQUEST_GRANTED_NO_ERRORS;
	  }
	}
      }
      
    }
    /* If we are here it means there is no address to lease in range list of host or
     * its subnet/interface.
     */
    /* Note: If you don't check scope return value will always be
     * REQUESTED_IP_ADDR_UNAVAILABLE
     */
    if(flag)
      return IP_ADDR_SCOPE_UNAVAILABLE;
    return REQUESTED_IP_ADDR_UNAVAILABLE; /* I don't think this is a good return value but
					     there is no other value which is good enough */
  }
  else {
    /* any address can be assigned */
    if(lease->onlink) {
      temp_range = interface->range_list_head;
    }
    else {
      temp_range = subnet->range_list_head;
    }
    
    for(; temp_range; temp_range = temp_range->next) {
	  
      if((A && !temp_range->dns_update_A_allowed) ||
	 (P && !temp_range->dns_update_P_allowed))
	/* We can't lease an address where dns update is not allowed and client is
	 * asking for update.
	 */
	continue;
	  
      if(temp_range->max_preferred_lifetime >= lease->preferred_lifetime &&
	 temp_range->max_valid_lifetime >= lease->valid_lifetime) {
	/*
	  if(!lease->onlink &&
	  !IN6_ARE_PREFIXES_EQUAL(temp_range->start, (lease->un).st.subnet_prefix,
	  (lease->un).st.subnet_prefix_len))
	  // For off link clients desired prefix must be made available
	  continue;
	*/
	temp_addr = find_unleased_addr_in_range_with_prefix(temp_range, &lease->ip_addr,
							    prefix_len, t_lease_list_head);
	if(temp_addr) {

	  /* If you want to check scope uncomment this comment
	  if(lease->scope != 0) {
	    scope_available         = (temp_range->scope == lease->scope);
	    flag                    = 1;
	    if(!scope_available)
	      continue;
	  }
	  */
	  
	  lease->scope              = temp_range->scope;
	  lease->ip_addr            = *temp_addr;
	  lease->ip_addr_prefix_len = temp_range->prefix_len;
	  
	  if(lease->preferred_lifetime == 0)
	    lease->preferred_lifetime = temp_range->default_preferred_lifetime;
	  
	  if(lease->valid_lifetime == 0)
	    lease->valid_lifetime = temp_range->default_valid_lifetime;
	  
	  lease->default_preferred_lifetime = temp_range->default_preferred_lifetime;
	  lease->default_valid_lifetime     = temp_range->default_valid_lifetime;
	  lease->max_preferred_lifetime     = temp_range->max_preferred_lifetime;
	  lease->max_valid_lifetime         = temp_range->max_valid_lifetime;
	  lease->dns_update_A_allowed       = temp_range->dns_update_A_allowed;
	  lease->dns_update_P_allowed       = temp_range->dns_update_P_allowed;
	  free(temp_addr);
	  return REQUEST_GRANTED_NO_ERRORS;
	}
      }
    }
  }
  if(flag)
    return IP_ADDR_SCOPE_UNAVAILABLE;
  return REQUESTED_IP_ADDR_UNAVAILABLE; /* I don't think this is a good return value but
					   there is no other value which is good enough */
}

