struct in6_addr_with_prefix{

  struct in6_addr_with_prefix *next;
  struct in6_addr              prefix;
  uint8_t                      prefix_len;

};

struct range{

  uint32_t         default_preferred_lifetime;
  uint32_t         default_valid_lifetime;
  uint32_t         max_preferred_lifetime;
  uint32_t         max_valid_lifetime;
  uint8_t          scope: 3;
  uint8_t          dns_update_A_allowed: 1;
  uint8_t          dns_update_P_allowed: 1;

  IN6_ADDR_WITH_PREFIX *dn_server_list_head;
  char                  domain_name_suffix[MAX_DNS_NAME];
  void                 *parent;
  //uint8_t          preference;

  //PREFIX_LIST     *adv_prefix_list_head;
  //IN6_ADDR_WITH_PREFIX  server_addr;
  uint8_t          prefix_len;
  struct in6_addr  start;
  struct in6_addr  end;
  struct range    *next;

};

struct host{
  uint32_t         default_preferred_lifetime;
  uint32_t         default_valid_lifetime;
  uint32_t         max_preferred_lifetime;
  uint32_t         max_valid_lifetime;
  uint8_t          scope: 3;
  uint8_t          dns_update_A_allowed: 1;
  uint8_t          dns_update_P_allowed: 1;

  IN6_ADDR_WITH_PREFIX *dn_server_list_head;
  char                  domain_name_suffix[MAX_DNS_NAME];
  void                 *parent;

  uint8_t          preference;

  PREFIX_LIST     *adv_prefix_list_head;
  IN6_ADDR_WITH_PREFIX  server_addr;
  RANGE           *range_list_head;
  struct in6_addr  link_local_addr;
  //struct in6_addr  subnet_prefix;
  //uint8_t          subnet_prefix_len;


  S_IN6_ADDR_LIST *fixed_addr_list_head;
  struct host     *next;
};

struct subnet{
  uint32_t              default_preferred_lifetime;
  uint32_t              default_valid_lifetime;
  uint32_t              max_preferred_lifetime;
  uint32_t              max_valid_lifetime;
  uint8_t               scope: 3;
  uint8_t               dns_update_A_allowed: 1;
  uint8_t               dns_update_P_allowed: 1;

  IN6_ADDR_WITH_PREFIX *dn_server_list_head;
  char                  domain_name_suffix[MAX_DNS_NAME];
  void                 *parent;

  uint8_t               preference;

  PREFIX_LIST          *adv_prefix_list_head;
  IN6_ADDR_WITH_PREFIX  server_addr;
  RANGE                *range_list_head;

  HOST                 *host_list_head;

  IN6_ADDR_WITH_PREFIX *addr_list_head;
  struct subnet        *next;
};

struct interface{
  uint32_t              default_preferred_lifetime;
  uint32_t              default_valid_lifetime;
  uint32_t              max_preferred_lifetime;
  uint32_t              max_valid_lifetime;
  uint8_t               scope: 3;
  uint8_t               dns_update_A_allowed: 1;
  uint8_t               dns_update_P_allowed: 1;

  IN6_ADDR_WITH_PREFIX *dn_server_list_head;
  char                  domain_name_suffix[MAX_DNS_NAME];
  void                 *parent;

  uint8_t               preference;

  PREFIX_LIST          *adv_prefix_list_head;
  IN6_ADDR_WITH_PREFIX  server_addr;
  RANGE                *range_list_head;

  HOST                 *host_list_head;

  uint32_t              index;
  char                  name[IFNAMSIZ];
  struct in6_addr      *link_local_addr;
  IN6_ADDR_LIST        *addr_list_head;
  struct interface     *next;

};
