# define INITIALISE_SOCKADDR(x){                                 \
  bzero((char *) &(x), sizeof((x)));                             \
  (x).sin6_family   = AF_INET6;                                  \
  (x).sin6_flowinfo = htonl(0);                                  \
  (x).sin6_scope_id = 0;                                         \
}

# define IN6_IS_ADDR_GLOBAL(x) ( !IN6_IS_ADDR_UNSPECIFIED(x) &&  \
                                 !IN6_IS_ADDR_LOOPBACK(x)    &&  \
                                 !IN6_IS_ADDR_MULTICAST(x)   &&  \
                                 !IN6_IS_ADDR_LINKLOCAL(x)   &&  \
                                 !IN6_IS_ADDR_SITELOCAL(x))


int IN6_ARE_PREFIXES_EQUAL(struct in6_addr *a1, struct in6_addr *a2,
			   int prefix_len){
  int full_bytes     = prefix_len / 8;
  int remaining_bits = prefix_len % 8;
  int i;
  char *c1, *c2, mask;
  
  for(c1 = (char *)a1, c2 = (char *)a2, i = 0; i < full_bytes;
      i++, c1++, c2++)
    if(*((u_int8_t *)c1) != *((u_int8_t *)c2))
      return 0;
  
  if(remaining_bits == 0)
    return 1;

  mask = ((1 << remaining_bits) - 1) << (8 - remaining_bits);
  if((*c1 && mask) != (*c2 && mask))
    return 0;

  return 1;
  
}
