# include "inet.h"
/*
 * Server listens on 547, sends on whatever src port it likes
 * Client listens on 546, sends on whatever src port it likes
 *
 * int   SERVER_PORT    = 547;
 * int   CLIENT_PORT    = 546;
 */
extern const struct in6_addr in6addr_any;
//# define DEBUG
# define LL
# define INITIALISE_SOCKADDR(x){                                                      \
  bzero((char *) &(x), sizeof((x)));                                                  \
                                                                                      \
  (x).sin6_family   = AF_INET6;                                                       \
  (x).sin6_flowinfo = htonl(0);                                                       \
  (x).sin6_scope_id = 0;                                                              \
}


main(int argc, char *argv[]){
  int                  agent_fd, reply_fd, link_local_fd, adm_src_fd = -1, msg_no = 1;
  int                  nfds = -1, n, childpid, adm_src_socklen, on;
  uint32_t             main_interface, in_multi_if, out_multi_if;
  char                *recv_msg, *send_msg, name[64], _name_[64];
  struct sockaddr_in6  agent_sockaddr, link_local_sockaddr, adm_src_sockaddr, cli_sockaddr, reply_sockaddr;
  fd_set               f, temp_f;
  struct timeval       timeout;
  struct ipv6_mreq     socket_opt;
  struct msghdr        msg;
  struct iovec         iov[1];
  struct{
    struct cmsghdr     c_cm;
    struct in6_pktinfo c_pi;
  }c_cmsg;
  
#define pi	      c_cmsg.c_pi
  
  
  in_multi_if    = 1;
  out_multi_if   = 1;
  main_interface = 1;
  
  recv_msg = (char *) malloc(MAX_DHCP_MSG);
  send_msg = (char *) malloc(MAX_DHCP_MSG);

  FD_ZERO(&f);
  FD_ZERO(&temp_f);

  agent_fd = socket(AF_INET6, SOCK_DGRAM, 0);
  if(agent_fd < 0)
    err_dump("Error in opening datagram socket. Exiting...");

  on = 1;
  if (setsockopt(agent_fd, IPPROTO_IPV6, IPV6_RECVPKTINFO,
		 &on, sizeof(on)) == -1)
    err_dump("Couldn't set socket option to IPV6_RECVPKTINFO. Exiting...");
  
#ifdef LL
  
  printf("defined\n");
  n = inet_pton(AF_INET6, ALL_DHCP_AGENTS_ADDR,
                & socket_opt.ipv6mr_multiaddr);  
  if(n <= 0){
    if(n < 0)
      err_dump("Unknown AF(first) argument. Exiting...");
    else
      err_dump("Invalid address string. Exiting...");
  }

  // socket_opt.ipv6mr_multiaddr = "FF02::1:2"; 
  socket_opt.ipv6mr_interface = in_multi_if;
  n = setsockopt(agent_fd, IPPROTO_IPV6, IPV6_JOIN_GROUP, (char *) &socket_opt, sizeof(socket_opt));
  if(n == -1){
    printf("Couldn't set socket option to IPV6_JOIN_GROUP to %s. ",
	   inet_ntop(AF_INET6, &socket_opt.ipv6mr_multiaddr, name, 64));
    err_dump("Exiting...");
  }
  
  n = inet_pton(AF_INET6, ALL_DHCP_SERVERS_ADDR,
                & socket_opt.ipv6mr_multiaddr);  
  if(n <= 0){
    if(n < 0)
      err_dump("Unknown AF(first) argument. Exiting...");
    else
      err_dump("Invalid address string. Exiting...");
  }
  
  // socket_opt.ipv6mr_multiaddr = "FF05::1:3"; 
  socket_opt.ipv6mr_interface = in_multi_if;
  n = setsockopt(agent_fd, IPPROTO_IPV6, IPV6_JOIN_GROUP, (char *) &socket_opt, sizeof(socket_opt));
  if(n == -1){
    printf("Couldn't set socket option to IPV6_JOIN_GROUP to %s. ",
	   inet_ntop(AF_INET6, &socket_opt.ipv6mr_multiaddr, name, 64));
    err_dump("Exiting...");
  }
  
#endif
  
  link_local_fd = socket(AF_INET6, SOCK_DGRAM, 0);
  if(link_local_fd < 0)
    err_dump("Error in opening datagram socket. Exiting...");
  
  on = 1;
  if (setsockopt(link_local_fd, IPPROTO_IPV6, IPV6_RECVPKTINFO,
		 &on, sizeof(on)) == -1)
    err_dump("Couldn't set socket option to IPV6_RECVPKTINFO. Exiting...");
  /*
#ifdef LL
  printf("defined\n");
  n = inet_pton(AF_INET6, ALL_DHCP_AGENTS_ADDR,
                & socket_opt.ipv6mr_multiaddr);  
  if(n <= 0){
    if(n < 0)
      err_dump("Unknown AF(first) argument. Exiting...");
    else
      err_dump("Invalid address string. Exiting...");
  }

  socket_opt.ipv6mr_interface = in_multi_if;
  n = setsockopt(link_local_fd, IPPROTO_IPV6, IPV6_JOIN_GROUP, (char *) &socket_opt, sizeof(socket_opt));
  if(n == -1){
    printf("Couldn't set socket option to IPV6_JOIN_GROUP to %s. ",
	   inet_ntop(AF_INET6, &socket_opt.ipv6mr_multiaddr, name, 64));
    err_dump("Exiting...");
  }
  
  n = inet_pton(AF_INET6, ALL_DHCP_SERVERS_ADDR,
                & socket_opt.ipv6mr_multiaddr);  
  if(n <= 0){
    if(n < 0)
      err_dump("Unknown AF(first) argument. Exiting...");
    else
      err_dump("Invalid address string. Exiting...");
  }
  
  socket_opt.ipv6mr_interface = in_multi_if;
  n = setsockopt(link_local_fd, IPPROTO_IPV6, IPV6_JOIN_GROUP, (char *) &socket_opt, sizeof(socket_opt));
  if(n == -1){
    printf("Couldn't set socket option to IPV6_JOIN_GROUP to %s. ",
	   inet_ntop(AF_INET6, &socket_opt.ipv6mr_multiaddr, name, 64));
    err_dump("Exiting...");
  }
  
#endif
  */
  reply_fd = socket(AF_INET6, SOCK_DGRAM, 0);
  if(reply_fd < 0)
    err_dump("Error in opening datagram socket. Exiting...");
  /* Set sockopt to  IPV6_MULTICAST_IF for DHCP reconfigure messages */
  if(setsockopt(reply_fd, IPPROTO_IPV6, IPV6_MULTICAST_IF,
		 &out_multi_if, sizeof(out_multi_if)) < 0){
    err_dump("Couldn't set socket option to  IPV6_MULTICAST_IF. Exiting...");
  }
   
  INITIALISE_SOCKADDR(link_local_sockaddr);
#ifdef SIN6_LEN
  link_local_sockaddr.sin6_len = sizeof(link_local_sockaddr);
#endif
  link_local_sockaddr.sin6_port = htons(AGENT_PORT);
  link_local_sockaddr.sin6_scope_id = 1;
  n = inet_pton(AF_INET6, LINK_LOCAL_ADDR,
		& link_local_sockaddr.sin6_addr);
  if(n != 1){
    if(n < 0)
      err_dump("Unknown AF(first) argument. Exiting...");
    else
      err_dump("Invalid address string. Exiting...");
  }
  //link_local_sockaddr.sin6_addr = in6addr_any;
  if((n = bind(link_local_fd, (struct sockaddr *) &link_local_sockaddr, 
	       sizeof(link_local_sockaddr))) < 0){
    printf("bind: %d\a\n",n);
    err_dump("Error while binding address..............! Exiting...");
  }
  
  INITIALISE_SOCKADDR(agent_sockaddr);
  agent_sockaddr.sin6_port = htons(AGENT_PORT);
  agent_sockaddr.sin6_addr = in6addr_any;
  
  if((n = bind(agent_fd, (struct sockaddr *) &agent_sockaddr, 
	       sizeof(agent_sockaddr))) < 0){
    printf("bind: %d\a\n",n);
    err_dump("Error while binding address! Exiting...");
  }

  INITIALISE_SOCKADDR(reply_sockaddr);
  reply_sockaddr.sin6_port = htons(0);
  reply_sockaddr.sin6_addr = in6addr_any;
  if((n = bind(reply_fd, (struct sockaddr *) &reply_sockaddr, 
	       sizeof(reply_sockaddr))) < 0){
    printf("bind: %d\a\n",n);
    err_dump("Error while binding address! Exiting...");
  }
  
  FD_SET(agent_fd, &f);
  nfds = agent_fd;

  FD_SET(link_local_fd, &f);
  if(link_local_fd > nfds)
    nfds = link_local_fd;

  temp_f = f;

  /* Initialise data structures for receiving ancillary data */
  iov[0].iov_base = recv_msg;
  iov[0].iov_len  = MAX_DHCP_MSG;
  msg.msg_name    = (caddr_t) &cli_sockaddr;
  msg.msg_namelen = sizeof(cli_sockaddr);
  msg.msg_iov     = &iov[0];
  msg.msg_iovlen  = 1;
  msg.msg_control = (caddr_t)&c_cmsg;
  msg.msg_controllen = sizeof(c_cmsg);
  
 
  while(1){
    n = select(nfds + 1, &f, (fd_set *)0, (fd_set *)0, NULL);
#ifdef DEBUG
    printf("select = %d\a\n", n);
#endif
    
    if(n < 0)
      err_dump("Error in select\a\n");
    
    if(n == 0){
      continue;
    }
    
    if(FD_ISSET(agent_fd, &f)){
      /* Note: Only solicit messages are multicast???? */
      FD_CLR(agent_fd, &f);
      n = recvmsg(agent_fd, &msg, 0);
      if(n < 0)
	err_dump("err in recv");
      
      if(n == 0){
	printf("Connection closed\n");
      }
      else{
	recv_msg[n] = '\0';
	printf("Client: %s on interface %d name = %s cliaddr = %s..........................\n\n",
	       recv_msg, pi.ipi6_ifindex, if_indextoname(pi.ipi6_ifindex, name),
	       inet_ntop(AF_INET6, &cli_sockaddr.sin6_addr, _name_, 64));

	sprintf(send_msg, "from server: %d", msg_no++);
	if(sendto(reply_fd, send_msg, strlen(send_msg), 0, 
		  (struct sockaddr *)&cli_sockaddr, sizeof(cli_sockaddr)) < 0)
	  err_dump("Error in sendto! Exiting...");
	printf("Sent: %s\n", send_msg);
      }
      //handle_request_from_client(c_cmsg.c_pi.ipi6_ifindex, recv_msg, n, &cli_sockaddr);//, MULTICAST_PACKET);
    }
    if(FD_ISSET(link_local_fd, &f)){
      FD_CLR(link_local_fd, &f);
      n = recvmsg(link_local_fd, &msg, 0);
      if(n < 0)
	err_dump("err in recv");
      
      if(n == 0){
	printf("Connection closed\n");
      }
      else{
	recv_msg[n] = '\0';
	printf("Client: %s on interface %d name = %s cliaddr = %s\n\n",
	       recv_msg, pi.ipi6_ifindex, if_indextoname(pi.ipi6_ifindex, name),
	       inet_ntop(AF_INET6, &cli_sockaddr.sin6_addr, _name_, 64));

	sprintf(send_msg, "from server: %d", msg_no++);
	if(sendto(reply_fd, send_msg, strlen(send_msg), 0, 
		  (struct sockaddr *)&cli_sockaddr, sizeof(cli_sockaddr)) < 0)
	  err_dump("Error in sendto! Exiting...");
	printf("Sent: %s\n", send_msg);
      }
      
    }
    f = temp_f;
  }

}
