# include "inet.h"

extern const struct in6_addr in6addr_any;

main(int argc, char *argv[]){
  
  int                 sockfd, n, cli_socklen, reply_no = 1, temp, rep_sockfd;
  struct sockaddr_in6 cli_sockaddr, serv_sockaddr;
  char                recv_msg[MAX_MSG_SIZE + 1], send_msg[MAX_MSG_SIZE];
  char                name[128], name_[128];
  fd_set              f;


  bzero((char *) &serv_sockaddr, sizeof(serv_sockaddr));

#ifdef SIN6_LEN
  serv_sockaddr.sin6_len      = sizeof(serv_sockaddr);            /* 4.3 BSD doesn't have this field      */
#endif

  serv_sockaddr.sin6_family   = AF_INET6;                         /* Family as required for Ipv6          */
  serv_sockaddr.sin6_port     = htons(SERVER_PORT);               /* Server listens on SERVER_PORT        */
  serv_sockaddr.sin6_flowinfo = htonl(0);                         /* Flow & Traffic Class are unimportant */
  serv_sockaddr.sin6_addr     = in6addr_any;
  serv_sockaddr.sin6_scope_id = 0;

  sockfd     = socket(AF_INET6, SOCK_STREAM, 0);

  if(sockfd < 0)
    err_dump("Error in opening datagram socket! Exiting...");

  if((n = bind(sockfd, (struct sockaddr *) &serv_sockaddr,
	  sizeof(serv_sockaddr))) < 0){
    printf("bind: %d\n",n);
    printf("address = %s\n",inet_ntop(AF_INET6, &serv_sockaddr.sin6_addr, name, 127));
    err_dump("Error while binding address! Exiting...");
  }

  listen(sockfd, 5);
  cli_socklen = sizeof(cli_sockaddr);
  rep_sockfd  = accept(sockfd, (struct sockaddr *)&cli_sockaddr, &cli_socklen);
  FD_ZERO(&f);
  FD_SET(rep_sockfd, &f);
/*printf("address = %s\n",inet_ntop(AF_INET6, &serv_sockaddr.sin6_addr, name, 127));*/

  while(1){
    n            = select(rep_sockfd + 1, &f, (fd_set *)0, (fd_set *)0, NULL);
    if(n < 0)
      err_dump("error in select");
    printf("select = %d.........\n", n);
    
    n            = recv(rep_sockfd, recv_msg, MAX_MSG_SIZE, 0);

    if(n < 0)
      err_dump("Error in recv! Exiting...");
    
    if(n == 0)
      err_dump("Received zero sized msg. Peer closed the connection.");

    recv_msg[n] = '\0';
    printf("Received: Client to server: %s cli_addr = %s\n",
	   recv_msg,
	   inet_ntop(AF_INET6, &cli_sockaddr.sin6_addr, name, 127));

    sprintf(send_msg,"This is reply no. %d from server",reply_no);
    if(send(rep_sockfd, send_msg, strlen(send_msg), 0) < 0)
      /*          \___________________________________
       *                                              \
       * For the moment let the server send using same port as it was listening on. 
       * You can change the port no. later for sending.
       */
      err_dump("Error in send! Exiting...");

    printf("Sent: Server to client: %s cli addr = %s\n",
	   send_msg,
	   inet_ntop(AF_INET6, &cli_sockaddr.sin6_addr, name, 127));
    reply_no++;
    /*if(reply_no == 3){
      close(rep_sockfd);
      exit(0);
      }*/
  }
}
