# include <stdio.h>
# include <sys/types.h>
# include <sys/socket.h>
# include <sys/ioctl.h>
# include <netinet/in.h>
# include <arpa/inet.h>
# include <net/if.h>
# include <netdb.h>

void using_ioctl(){
  struct ifconf ifc;
  struct ifreq *ifr;
  int sockfd;
  char buf[8192];
  int i, n;

  sockfd = socket(AF_INET6, SOCK_DGRAM, 0);

  if(sockfd < 0){
    printf("Can't create socket. Exiting...\n");
    exit(0);
  }

  ifc.ifc_len = sizeof(buf);
  ifc.ifc_buf = (caddr_t)buf;
  i = ioctl(sockfd, SIOCGIFCONF, &ifc);

  if (i < 0){
    printf("ioctl: SIOCGIFCONF error!. Exiting...\n");
    exit(0);
  }

  n = ifc.ifc_len/sizeof(struct ifreq);

  for (ifr = ifc.ifc_req; n > 0; n--, ifr++){
    if (ifr->ifr_addr.sa_family != AF_INET)
      printf("Not a AF_INET(%3d) interface: %3d: ", AF_INET, ifr->ifr_addr.sa_family);
    printf("%s\n",ifr->ifr_name);
  }

  printf("AF_INET6 = %d",AF_INET6);
}

main(){
  struct if_nameindex *all, interface;
  int i;

  all = if_nameindex();
  
  for(i = 0, interface = all[i]; 
      interface.if_index != 0 || interface.if_name != NULL; 
      interface = all[i++]){
  /*
  while(interface.if_index ){
  if*/
    printf("interface[%d]: index = %d name = %s\n", 
	   i,
	   interface.if_index, 
	   interface.if_name);
  }
  
  printf("test all->%p %d\n",all, all);

  printf("---------------------------------------\n");
  using_ioctl();
}
/*
struct	ifreq {
#define	IFNAMSIZ	16
	char	ifr_name[IFNAMSIZ];		// if name, e.g. "en0" 
	union {
		struct	sockaddr ifru_addr;
		struct	sockaddr ifru_dstaddr;
		struct	sockaddr ifru_broadaddr;
		short	ifru_flags;
		int	ifru_metric;
		int	ifru_mtu;
		int	ifru_phys;
		int	ifru_media;
		u_short	ifru_scid6[2];
		caddr_t	ifru_data;
	} ifr_ifru;
#define	ifr_addr	ifr_ifru.ifru_addr	// address 
#define	ifr_dstaddr	ifr_ifru.ifru_dstaddr	// other end of p-to-p link 
#define	ifr_broadaddr	ifr_ifru.ifru_broadaddr	// broadcast address
#define	ifr_flags	ifr_ifru.ifru_flags	// flags 
#define	ifr_metric	ifr_ifru.ifru_metric	// metric 
#define	ifr_mtu		ifr_ifru.ifru_mtu	// mtu 
#define ifr_phys	ifr_ifru.ifru_phys	// physical wire 
#define ifr_media	ifr_ifru.ifru_media	// physical media 
#define ifr_scid6	ifr_ifru.ifru_scid6	// IPv6 scope IDs 
#define	ifr_data	ifr_ifru.ifru_data	// for use by interface 
};
*/
