# include <stdio.h>
# include <sys/types.h>
# include <sys/socket.h>
# include <sys/ioctl.h>
# include <netinet/in.h>
# include <arpa/inet.h>
# include <net/if.h>
# include <netdb.h>

void using_ioctl(){
  struct ifconf ifc;
  struct ifreq *ifr;
  int sockfd;
  char buf[8192], b[128];
  int i, n;
  struct sockaddr_in *s;

  sockfd = socket(AF_INET, SOCK_DGRAM, 0);

  if(sockfd < 0){
    printf("Can't create socket. Exiting...\n");
    exit(0);
  }

  ifc.ifc_len = sizeof(buf);
  ifc.ifc_buf = (caddr_t)buf;
  i = ioctl(sockfd, SIOCGIFCONF, &ifc);

  if (i < 0){
    printf("ioctl: SIOCGIFCONF error!. Exiting...\n");
    exit(0);
  }

  n = ifc.ifc_len/sizeof(struct ifreq);

  for (ifr = ifc.ifc_req; n > 0; n--, ifr++){
    s = (struct sockaddr_in *) &ifr->ifr_addr;
    if (s->sin_family != AF_INET)
      printf("Not a AF_INET(%3d) interface: family = %3d: addr = %s", 
	     AF_INET,
	     s->sin_family,
	     inet_ntop(AF_INET, & s->sin_addr, b, 128));
    printf("%s family = %u\n",ifr->ifr_name, ifr->ifr_addr.sa_family);
  }

  // printf("AF_INET6 = %d",AF_INET6);
}

void getifaddr(int index, struct ifreq *ifr){
  int  sockfd, i;
  char buf[128];
  struct sockaddr_in *s;

  if_indextoname(index, ifr->ifr_name);
  printf("name for [%d] = %s\n", index, ifr->ifr_name);
  sockfd = socket(AF_INET, SOCK_DGRAM, 0);

  if(sockfd < 0){
    printf("Can't create socket. Exiting...\n");
    exit(0);
  }
  
  i = ioctl(sockfd, SIOCGIFADDR, ifr);
  if (i < 0){
    printf("ioctl: SIOCGIFADDR error!. Exiting...\n");
    exit(0);
  }
  
  s = (struct sockaddr_in *) &ifr->ifr_addr;
  printf("\taddr = %s mtu = %d family = %u\n", 
	 inet_ntop(AF_INET, & s->sin_addr, buf, 128),
	 ifr->ifr_mtu,
	 s->sin_family);
}

main(){
  struct if_nameindex *all, interface;
  struct ifreq        result;
  int i;

  all = if_nameindex();
  
  for(i = 0, interface = all[i]; 
      interface.if_index != 0 || interface.if_name != NULL; 
      interface = all[i++]){
  /*
  while(interface.if_index ){
  if*/
    printf("interface[%d]: index = %d name = %s\n", 
	   i,
	   interface.if_index, 
	   interface.if_name);
  }
  
  printf("test all->%p %d\n",all, all);

  printf("---------------------------------------\n");
  using_ioctl();

  getifaddr(1, &result);
}
/*
struct	ifreq {
#define	IFNAMSIZ	16
	char	ifr_name[IFNAMSIZ];		// if name, e.g. "en0" 
	union {
		struct	sockaddr ifru_addr;
		struct	sockaddr ifru_dstaddr;
		struct	sockaddr ifru_broadaddr;
		short	ifru_flags;
		int	ifru_metric;
		int	ifru_mtu;
		int	ifru_phys;
		int	ifru_media;
		u_short	ifru_scid6[2];
		caddr_t	ifru_data;
	} ifr_ifru;
#define	ifr_addr	ifr_ifru.ifru_addr	// address 
#define	ifr_dstaddr	ifr_ifru.ifru_dstaddr	// other end of p-to-p link 
#define	ifr_broadaddr	ifr_ifru.ifru_broadaddr	// broadcast address
#define	ifr_flags	ifr_ifru.ifru_flags	// flags 
#define	ifr_metric	ifr_ifru.ifru_metric	// metric 
#define	ifr_mtu		ifr_ifru.ifru_mtu	// mtu 
#define ifr_phys	ifr_ifru.ifru_phys	// physical wire 
#define ifr_media	ifr_ifru.ifru_media	// physical media 
#define ifr_scid6	ifr_ifru.ifru_scid6	// IPv6 scope IDs 
#define	ifr_data	ifr_ifru.ifru_data	// for use by interface 
};
*/
