# include "inet.h"

main(int argc, char *argv[]){
  int                 sockfd, n, cli_socklen[2], nfds;
  struct sockaddr_in6 cli_sockaddr[2], serv_sockaddr;
  char                recv_msg[MAX_MSG_SIZE + 1], send_msg[MAX_MSG_SIZE];
  fd_set              f;
  struct timeval      timeout;
  int                 fd[2], no_of_fd, i = 0;
  

  if(argc == 1)
    err_dump("Please enter a port no.");

  sockfd     = socket(AF_INET6, SOCK_STREAM, 0);

  if(sockfd < 0)
    err_dump("Error in opening stream socket! Exiting...");


  bzero((char *) &serv_sockaddr, sizeof(serv_sockaddr));

#ifdef SIN6_LEN
  serv_sockaddr.sin6_len      = sizeof(serv_sockaddr);            /* 4.3 BSD doesn't have this field      */
#endif

  serv_sockaddr.sin6_family   = AF_INET6;                         /* Family as required for Ipv6          */
  serv_sockaddr.sin6_port     = htons(atoi(argv[1]));               /* Server listens on SERVER_PORT        */
  serv_sockaddr.sin6_flowinfo = htonl(0);                         /* Flow & Traffic Class are unimportant */
  n = inet_pton(AF_INET6, SERVER_ADDRESS,                         /* Converting address to binary format. */
		& serv_sockaddr.sin6_addr);
  if(n <= 0){
    if(n < 0)
      err_dump("Unknown AF(first) argument. Exiting...");
    else
      err_dump("Invalid address string. Exiting...");
  }

  if(connect(sockfd, (struct sockaddr *) & serv_sockaddr, sizeof(serv_sockaddr)) < 0)
      err_dump("Can't connect to server. Exiting...");

  while(1){
    printf("Press enter for sending more: ");
    getchar();
    sprintf(send_msg, "This is message no %d from %d", i++, getpid());
    n = send(sockfd, send_msg, strlen(send_msg),0);
    printf("Sent: %s\n", send_msg);
  }/* while */
}
