# include "inet.h"
# define NCLIENTS 5

struct list{
  int         fd;
  struct list *next;
};

typedef struct list LIST;

main(int argc, char *argv[]){
  int                 sockfd, n, cli_socklen[5], nfds;
  struct sockaddr_in6 cli_sockaddr[5], serv_sockaddr;
  char                recv_msg[MAX_MSG_SIZE + 1], send_msg[MAX_MSG_SIZE], name[100];
  fd_set              f;
  struct timeval      timeout;
  LIST                *head, *temp, *tail;
  int                 fd[5], no_of_fd, i;
  
  if(argc == 1)
    err_dump("Please enter a port no.");

  sockfd     = socket(AF_INET6, SOCK_STREAM, 0);

  if(sockfd < 0)
    err_dump("Error in opening stream socket! Exiting...");


  bzero((char *) &serv_sockaddr, sizeof(serv_sockaddr));

#ifdef SIN6_LEN
  serv_sockaddr.sin6_len      = sizeof(serv_sockaddr);            /* 4.3 BSD doesn't have this field      */
#endif

  serv_sockaddr.sin6_family   = AF_INET6;                         /* Family as required for Ipv6          */
  serv_sockaddr.sin6_port     = htons(atoi(argv[1]));               /* Server listens on SERVER_PORT        */
  serv_sockaddr.sin6_flowinfo = htonl(0);                         /* Flow & Traffic Class are unimportant */
  n = inet_pton(AF_INET6, SERVER_ADDRESS,                         /* Converting address to binary format. */
		& serv_sockaddr.sin6_addr);
  if(n <= 0){
    if(n < 0)
      err_dump("Unknown AF(first) argument. Exiting...");
    else
      err_dump("Invalid address string. Exiting...");
  }

  if((n = bind(sockfd, (struct sockaddr *) &serv_sockaddr,
	  sizeof(serv_sockaddr))) < 0){
    printf("bind: %d\n",n);
    printf("address = %s\n",inet_ntop(AF_INET6, &serv_sockaddr.sin6_addr, name, 127));
    err_dump("Error while binding address! Exiting...");
  }

  listen(sockfd, 5);


  FD_ZERO(&f);
  FD_SET(sockfd, &f);
  nfds            = sockfd;
  timeout.tv_sec  = 1;
  timeout.tv_usec = 0;
  no_of_fd        = 0;
    
  while(1){
    n = select(nfds + 1, &f, (fd_set *)0, (fd_set *)0, NULL);
    printf("select = %d \n", n);
    if(n < 0)
      printf("\a\n");
    else if(n == 0){
      // check entire list for timeout and take necessary action
      //continue;
    }
    else{
      if(FD_ISSET(sockfd, &f)){
	printf("accepting: %d times\n", no_of_fd + 1);
	cli_socklen[no_of_fd] = sizeof(cli_sockaddr[no_of_fd]);
	fd[no_of_fd] = accept(sockfd, (struct sockaddr *)&cli_sockaddr[no_of_fd], &cli_socklen[no_of_fd]);
	no_of_fd++;
      }
      
      for(i = 0; i < no_of_fd; i++){
	if(FD_ISSET(fd[i], &f)){
	  n = recv(fd[i], recv_msg, MAX_MSG_SIZE, 0);
	  if(n <= 0){
	    int k;
	    close(fd[i]);
	    for(k = i; k < no_of_fd -1 ; k++)
	      fd[k] = fd[k+1];
	    no_of_fd--;
	    //err_dump("received length < 0\n");
	  }
	  else{
	    recv_msg[n] = '\0';
	    printf("i = %d msg = %s\n", i, recv_msg);
	  }
	}
      }
      

    }
    FD_ZERO(&f);
    FD_SET(sockfd, &f);
    nfds = sockfd;
    for(i = 0; i < no_of_fd; i++){
      FD_SET(fd[i], &f);
      if(nfds < fd[i])
	nfds = fd[i];
    }
    
  }/* while */
}
